<?php

class Controller_forum extends Controller {


    function __construct() {

    }
	
	public function Action_index(){
		
		$model = new Model_forum();
		$view = new View();
		
		$user = new User();
		
		$logAccess = $user->user();
		
		if(!$logAccess) 
			$this->redirect('/');
		
		$view->generate('forum', ['array'=>$model->readForumsParts(),'countForums'=>$model->countForums(),'user' => $user->user()]);
		
	}
	
	public function Action_part(){
		
		$model = new Model_forum();
		$view = new View();
		
		$this->GET(2);
		
		$curPart = $this->GET[1];
		$curPage = $this->GET[2] ? $this->GET[2] : 1;
		
	    $part = $model->issetPart($curPart);
		
		if(!$part)
			$this->redirect('/');
		
		$user = new User();
		
		$logAccess = $user->user();
		
		if(!$logAccess) 
			$this->redirect('/');
		
		
		$view->generate('forum_part', ['forum'=>$model->forumInfo($model->part->id_forum),
		                               'part'=>htmlspecialchars($model->part->name), 
		                               'id'=>$model->part->id, 
									   'themes'=>$model->readThemes($curPart, $curPage), 
									   'navigation_themes'=>$model->navigation_themes($curPart)]);
		
	}
	
	public function Action_theme(){
		
		$model = new Model_forum();
		$view = new View();
		
		
		$this->GET(4);
		
		$curForum = $this->GET[1];
		$curPart = $this->GET[2];
		$curTheme = $this->GET[3];
		
		$curPage = $this->GET[4] ? $this->GET[4] : 1;
		
	    $theme = $model->issetTheme($curForum, $curPart, $curTheme);
		
		if(!$theme)
			$this->redirect('/');
		
		$user = new User();
		
		$logAccess = $user->user();
		
		if(!$logAccess) 
			$this->redirect('/');
		
		$action = '/forum/theme/'.$curForum.'/'.$curPart.'/'.$curTheme.'/';
        $countPages = count($model->navigation_messages($curTheme));					
		
		if(isset($_POST['thememessage'])) {
			
			$model->addMessage($curForum, $curPart, $curTheme, $logAccess->id, $_POST['thememessage']);
			$countPages = count($model->navigation_messages($curTheme));
            $this->redirect($action.$countPages);
			
		}
		
		if($curPage > $countPages)
		   $this->redirect('/');
		
		$view->generate('forum_theme', ['forumInfo'=>$model->forumInfo($curForum),
		                              'partInfo'=>$model->partInfo($curPart),
		                              'theme_name'=>htmlspecialchars($model->theme->theme_name), 
		                              'id'=>$model->theme->id,
									  'action'=>$action,
									  'messages'=>$model->readMessages($curTheme, $curPage), 
									  'navigation_messages'=>$model->navigation_messages($curTheme)]);
		
	}	

	public function Action_addtheme(){
		
		$model = new Model_forum();
		$view = new View();
		$user = new User();
		
		$this->GET(1);
		
	    $part = $model->issetPart($this->GET[1]);
		
		if(!$part)
			$this->redirect('/');
		
		$logAccess = $user->user();
		
		if(!$logAccess) 
			$this->redirect('/');
		
		if(isset($_POST['themename'], $_POST['thememessage'])) {
			
			$id_forum = $model->part->id_forum;
			$id_part = $model->part->id;
			$id_author = $logAccess->id;
			$theme_name = $_POST['themename'];
			$theme_message = $_POST['thememessage'];
			
				$model->addTheme($id_forum, $id_part, $id_author, $theme_name, $theme_message);
			
			$redirect = '/forum/theme/'.$id_forum.'/'.$id_part.'/'.$model->id_theme;
			$this->redirect($redirect);
			
		}
			
		
		$view->generate('forum_addtheme', ['part'=>htmlspecialchars($model->part->name), 'id'=>$model->part->id]);
		
	}	
	

	 public function Action_pages() {

		$view = new View();
		$user = new User();
		$model = new Model_guestbook();
		$this->GET(1);
		
		$logAccess = $user->user();
		
		if(!$logAccess) 
			$this->redirect('/');
		
		$start = $this->GET[1] ? $this->GET[1] : 1;

        $view->generate('guestbook', ['messages'=>$model->read($start), 'navigation'=>$model->navigation()]);

    }
	
	
	public function Action_addforum() {
		
		$view = new View();

		$user = new User();
		$model = new Model_forum();
		
		$logAccess = $user->user();
		
		if(!$logAccess) 
			$this->redirect('/');
		
		if($logAccess->id != 1)
			$this->redirect('/');
		
		if(isset($_POST['forumname'])) {
			
			$model->addForum($_POST['forumname']);
			$this->redirect('/forum/addforum');
		
		}
		
		if(isset($_POST['deleteforum'])){
			
			$model->deleteForum($_POST['deleteforum']);
			$this->redirect('/forum/addforum');
			
		}

		if(isset($_POST['deletepart'])){
			
			$model->deletePart($_POST['deletepart']);
			$this->redirect('/forum/addforum');
			
		}		
		
		if(isset($_POST['id_forum'], $_POST['part_name'])) {
			
			$model->addForumPart($_POST['id_forum'], $_POST['part_name']);
			$this->redirect('/forum/addforum');
		
		}
		
		$view->generate('addforum', ['forums'=>$model->readForums(),'array'=>$model->readForumsParts(),'countForums'=>$model->countForums()]);

    }
	
}
