<?php

class Model_guestbook extends Model {

    function __construct() {

		parent::__construct();

    }

    public function create($id_user, $message){

		if(!empty($message)) {

			try {
				$addUser = $this->db->prepare("INSERT INTO guestbook (id_user,message,time) VALUES (?,?,?)");
                $addUser->execute([$id_user, $message, time()]);
            }
            catch(PDOException $e){
              die('Ошибка записи: ' . $e->getMessage());
            }

		}

	}

	public function read($start = 1){

		$go = ($start * 10) - 10;


		$result = [];

		$login = new User();

		$messages = $this->db->query("SELECT * FROM guestbook ORDER BY id DESC LIMIT $go ,10 ");
        $messages->setFetchMode(PDO::FETCH_OBJ);

         while($message = $messages->fetch())
         {
			$message->id_user = $login->login($message->id_user);
            $message->message = $this->smiles(htmlspecialchars($message->message));
			$message->time = date('d-m-y h:i:s', $message->time);

            $result[] = $message;
         }

		return $result;

	}

	public function navigation(){

		$result = [];

		$messages = $this->db->prepare("SELECT COUNT(*) as count FROM guestbook");
		$messages->execute();

		$count = $messages->fetch(PDO::FETCH_OBJ)->count;

		$pages = ceil($count/10);

		if($pages > 1)
            for($i=1; $i<=$pages; ++$i)
				$result[] = $i;

	return $result;
	}

	public function smiles($text){

		$search  = ['=))', '.хыхы.', '.еба.', '.пират.', '.вау.', '.палм.','.мда.','.ржу.','.олень.'];
        $replace = ['<img src="http://profiwm.ru/design/smiles/tongue.gif">',
					'<img src="http://profiwm.ru/design/smiles/PROFIWM_RU_11_51095_55780.gif">',
					'<img src="http://profiwm.ru/design/smiles/PROFIWM_RU_11_51096_365.gif">',
					'<img src="http://profiwm.ru/design/smiles/PROFIWM_RU_11_51094_smex3.gif">',
					'<img src="http://profiwm.ru/design/smiles/PROFIWM_RU_11_51093_pirat2.gif">',
				    '<img src="http://profiwm.ru/design/smiles/PROFIWM_RU_11_51092_megawow.gif">',
				    '<img src="http://profiwm.ru/design/smiles/PROFIWM_RU_11_51071_palm.gif">',
				    '<img src="http://profiwm.ru/design/smiles/PROFIWM_RU_11_51075_mda.gif">',
				    '<img src="http://profiwm.ru/design/smiles/PROFIWM_RU_11_51072_olen2-1.gif">',
				    '<img src="http://profiwm.ru/files/mail/PROFIWM_RU_11_45404_msn_111.gif">'];
        return str_replace($search, $replace, $text);

	}

}