<?php

class Model_registration extends Model {

    function __construct() {

		parent::__construct();

    }

    public function correctForm($login, $email, $first_password, $last_password, $captcha) {
		
		$login = trim($login);
		$email = trim($email);
		$first_password = trim($first_password);
		$last_password = trim($last_password);
		$captcha = trim($captcha);
		
		$this->errors = [];
		
		$login_ln = mb_strlen($login, 'UTF-8');
		$password_ln = mb_strlen($first_password, 'UTF-8');
		
		$exists = $this->db->prepare("SELECT COUNT(*) as count FROM users WHERE login = ?");
		$exists->execute([$login]);
		
		if($exists->fetch(PDO::FETCH_OBJ)->count > 0)
			$this->errors[] = 'Такой логин уже существует!';

		if ($login_ln < 3 or $login_ln > 30) 
			$this->errors[] = 'Неверная длинна логина!';
		if(!preg_match('/^([a-zа-яё1-9_])+?([a-zа-яё1-9_])+$/ui', $login)) 
			$this->errors[] = 'Некорректный логин!';
		
		if($password_ln < 3 or $password_ln > 30) 
			$this->errors[] = 'Неверная длинна пароля!';
		if($first_password != $last_password)
			$this->errors[] = 'Неверно повторили пароль!';
		
		if(!filter_var($email, FILTER_VALIDATE_EMAIL))
			$this->errors[] = 'Некорректный Email!';
		
		if ($captcha != $_SESSION['rand_code'])
			$this->errors[] = 'Неверный код с изображения!';
		
		unset($_SESSION['rand_code']);
		
		if(!empty($this->errors))
			return false;



        return true;
    }

	public function create($login, $email, $password) {
		
		try {
			
		  $password_hash = password_hash($password, PASSWORD_DEFAULT);
          $addUser = $this->db->prepare("INSERT INTO users (login,email,password) VALUES (?,?,?)");
          $addUser->execute([$login, $email, $password_hash]);
		  
		  setcookie('lg', $login, time() + 604800, '/'); 
          setcookie('ps', $password_hash, time() + 604800, '/'); 
		  
           }
           catch(PDOException $e){
              die('Ошибка записи: ' . $e->getMessage());
           }

    }

}
