<?php

class Model_repassword extends Model {

    function __construct() {

		parent::__construct();

    }

    public function repass($email){
		
		$email = trim($email);
		
		$this->errors = [];
		
		if(!filter_var($email, FILTER_VALIDATE_EMAIL))
			$this->errors[] = 'Вы ввели некорректный Email!';
		
		$exists = $this->db->prepare("SELECT id, COUNT(*) as count FROM users WHERE email = ?");
		$exists->execute([$email]);
		
		$emailUser = $exists->fetch(PDO::FETCH_OBJ);
		
		if($emailUser->count == 0)
			$this->errors[] = 'Пользователя с таким Email не существует!';
		
		if(!empty($this->errors))
			return false;
		
		$repass = uniqid();

		$newpass = $this->db->prepare("UPDATE users SET repass = ? WHERE email = ?");
		$newpass->execute([$repass, $email]);

		$host = $_SERVER['HTTP_HOST'];

		$text = 'Здравствуйте, Вы воспользовались ситемой восстановления пароля.
		Чтобы возобновить доступ к Вашему аккаунту, перейдите по ссылке:
		http://'.$host.'/repassword/new/'.$repass;

		$mail = new Mail('admin@'.$host);
        $mail->setFromName('Система '.$host);
        $mail->send($email, 'Восстановление пароля', $text);
		
	return true;	
	}
	
	public function hashEmail($hash){
		
		$exists = $this->db->prepare("SELECT COUNT(*) as count FROM users WHERE repass = ?");
		$exists->execute([$hash]);
		
		if($exists->fetch(PDO::FETCH_OBJ)->count == 0)
			return false;
		
		return true;
		
	}
	
	public function updatePassword($new_password, $new_password2, $hash){
		
		$new_password = trim($new_password);
		$new_password2 = trim($new_password2);
		
		$this->errors = [];
		
		$password_ln = mb_strlen($new_password, 'UTF-8');
		
		if($password_ln < 3 or $password_ln > 30) 
			$this->errors[] = 'Неверная длинна пароля!';
		
		if($new_password != $new_password2)
			$this->errors[] = 'Неверно повторили пароль!';
		
		if(!empty($this->errors))
			return false;
		
		$password_hash = password_hash($new_password, PASSWORD_DEFAULT);
		
		$newpass = $this->db->prepare("UPDATE users SET password = ? WHERE repass = ?");
		$newpass->execute([$password_hash, $hash]);
		
		$delhash = $this->db->prepare("UPDATE users SET repass = ? WHERE repass = ?");
		$delhash->execute([null, $hash]);
		
		return true;
	}

}
